// Scene.cpp: implementation of the Scene class.
//
//////////////////////////////////////////////////////////////////////

#include "Scene.h"

int Scene::sirka,Scene::vyska;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Scene::Scene()
{
	pvb1 = NULL;
	pvb2 = NULL;
	InitDX();
	if(fullscreen)ShowCursor(0);
	if(!CreateVertexBuffers()) { error=1; return; }
}

Scene::~Scene()
{
	if(pvb1!=NULL) pvb1->Release();
	if(pvb2!=NULL) pvb2->Release();
	if(fullscreen)ShowCursor(1);
}

void Scene::DrawDXScene()
{
	mat4 m;
    if( NULL == pd )return;

    // Clear the backbuffer to a blue color
	pd->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );

    // Begin the scene
    pd->BeginScene();

	if(keys['P'])pd->SetRenderState( D3DRS_FILLMODE, D3DFILL_WIREFRAME);
	else pd->SetRenderState( D3DRS_FILLMODE, D3DFILL_SOLID);

//	Point Lists
	m.m14 = 50;
	m.m24 = 450;
	pd->SetTransform( D3DTS_WORLD, (struct _D3DMATRIX *)(void*)&m );

	pd->SetStreamSource( 0, pvb1, sizeof(CUSTOMVERTEX) );
	pd->SetVertexShader( D3DFVF_CUSTOMVERTEX );
	pd->DrawPrimitive( D3DPT_POINTLIST, 0, 8 );

//	Line Lists
	m.m24 = 250;
	pd->SetTransform( D3DTS_WORLD, (struct _D3DMATRIX *)(void*)&m );

	pd->SetStreamSource( 0, pvb1, sizeof(CUSTOMVERTEX) );
	pd->SetVertexShader( D3DFVF_CUSTOMVERTEX );
	pd->DrawPrimitive( D3DPT_LINELIST, 0, 4 );

//	Line Strips
	m.m24 = 50;
	pd->SetTransform( D3DTS_WORLD, (struct _D3DMATRIX *)(void*)&m );

	pd->SetStreamSource( 0, pvb1, sizeof(CUSTOMVERTEX) );
	pd->SetVertexShader( D3DFVF_CUSTOMVERTEX );
	pd->DrawPrimitive( D3DPT_LINESTRIP, 0, 7 );

//	Triangle Lists
	m.m14 = 450;
	m.m24 = 450;
	pd->SetTransform( D3DTS_WORLD, (struct _D3DMATRIX *)(void*)&m );

	pd->SetStreamSource( 0, pvb1, sizeof(CUSTOMVERTEX) );
	pd->SetVertexShader( D3DFVF_CUSTOMVERTEX );
	pd->DrawPrimitive( D3DPT_TRIANGLELIST, 0, 2 );

//	Triangle Strips
	m.m24 = 250;
	pd->SetTransform( D3DTS_WORLD, (struct _D3DMATRIX *)(void*)&m );

	pd->SetStreamSource( 0, pvb1, sizeof(CUSTOMVERTEX) );
	pd->SetVertexShader( D3DFVF_CUSTOMVERTEX );
	pd->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 6 );

//	Triangle Fans
	m.m14 = 600;
	m.m24 = 100;
	pd->SetTransform( D3DTS_WORLD, (struct _D3DMATRIX *)(void*)&m );

	pd->SetStreamSource( 0, pvb2, sizeof(CUSTOMVERTEX) );
	pd->SetVertexShader( D3DFVF_CUSTOMVERTEX );
	pd->DrawPrimitive( D3DPT_TRIANGLEFAN, 0, 10 );

	m.Identity();
	m.Scale(0.3f,0.3f,0.3f);
	static float angle=0;
	angle+=1.f;
	m.RotZ( angle);
	m.m14 = 750;
	m.m24 = 50;
	pd->SetTransform( D3DTS_WORLD, (struct _D3DMATRIX *)(void*)&m );
	pd->DrawPrimitive( D3DPT_TRIANGLEFAN, 0, 2 );

	if(keys[VK_F12])SaveScreen_BMP();
	// End the scene
	pd->EndScene();

	// Present the backbuffer contents to the display
	pd->Present( NULL, NULL, NULL, NULL );
}

void Scene::ReSizeDXScene(int width, int height)
{
	sirka = width;
	vyska = height;
	
	D3DXMATRIX matProj;
//	D3DXMatrixPerspectiveFovLH( &matProj, FIELD_OF_VIEW*PI180, (float)sirka/(float)vyska, Z_NEAR_VIEW_PLANE, Z_FAR_VIEW_PLANE );
	D3DXMatrixOrthoOffCenterLH( &matProj, 0, 800, 0, 600, -1, 1 );
	pd->SetTransform( D3DTS_PROJECTION, &matProj );
}

void Scene::InitDX()
{
	if(!fullscreen)
	{
		RECT		WindowRect;					// miesto pre velkost okna
		WindowRect.left=(long)0;
		WindowRect.top=(long)0;
		GetClientRect(hWnd,&WindowRect);				//zistenie rozmerov uzivatelskej casti okna
		ReSizeDXScene(WindowRect.right,WindowRect.bottom);	//nastavenie perspektivy
	}
	else ReSizeDXScene(screen_x, screen_y);	//definovana v tomto subore

	pd->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE );
	
	// Enable z-buffering.
	pd->SetRenderState(D3DRS_ZENABLE, D3DZB_TRUE);
	pd->SetRenderState(D3DRS_ZFUNC, D3DCMP_LESS);

	mat4 m;	
	pd->SetTransform( D3DTS_VIEW, (struct _D3DMATRIX *)(void*)&m );
	pd->SetTransform( D3DTS_WORLD, (struct _D3DMATRIX *)(void*)&m );
}

int Scene::CreateVertexBuffers()
{
	CUSTOMVERTEX v1[8];

	int i=0;
	v1[i].v.set(  50.f*i, (i%2)*100.f, 0);	v1[i++].color = D3DCOLOR_RGBA( 255, 255, 255, 0);
	v1[i].v.set(  50.f*i, (i%2)*100.f, 0);	v1[i++].color = D3DCOLOR_RGBA( 255, 0, 0, 0);

	v1[i].v.set(  50.f*i, (i%2)*100.f, 0);	v1[i++].color = D3DCOLOR_RGBA( 0, 255, 0, 0);
	v1[i].v.set(  50.f*i, (i%2)*100.f, 0);	v1[i++].color = D3DCOLOR_RGBA( 0, 0, 255, 0);

	v1[i].v.set(  50.f*i, (i%2)*100.f, 0);	v1[i++].color = D3DCOLOR_RGBA( 0, 255, 255, 0);
	v1[i].v.set(  50.f*i, (i%2)*100.f, 0);	v1[i++].color = D3DCOLOR_RGBA( 255, 0, 255, 0);

	v1[i].v.set(  50.f*i, (i%2)*100.f, 0);	v1[i++].color = D3DCOLOR_RGBA( 255, 255, 0, 0);
	v1[i].v.set(  50.f*i, (i%2)*100.f, 0);	v1[i++].color = D3DCOLOR_RGBA( 255, 255, 255, 0);

	if( FAILED( pd->CreateVertexBuffer( 8*sizeof(CUSTOMVERTEX),0, 
								D3DFVF_CUSTOMVERTEX,D3DPOOL_DEFAULT, &pvb1 ) ) )return 0;
	void* p1;
	if( FAILED( pvb1->Lock( 0, 8*sizeof(CUSTOMVERTEX), (BYTE**)&p1, 0 ) ) )return 0;
	memcpy( p1, v1, 8*sizeof(CUSTOMVERTEX) );
	pvb1->Unlock();
	

	CUSTOMVERTEX v2[11];

	v2[0].v.set(0,0,0);
	vec v(90,0,0);
	for( i=1; i<11; i++)
	{
		v2[i].v = v;
		v.RotZ( 30.f);
	}
	i = 0;
	v2[i++].color = D3DCOLOR_RGBA( 255, 255, 255, 0);

	v2[i++].color = D3DCOLOR_RGBA( 255, 0, 0, 0);
	v2[i++].color = D3DCOLOR_RGBA( 0, 255, 0, 0);
	v2[i++].color = D3DCOLOR_RGBA( 0, 0, 255, 0);
	v2[i++].color = D3DCOLOR_RGBA( 0, 255, 255, 0);

	v2[i++].color = D3DCOLOR_RGBA( 255, 0, 255, 0);
	v2[i++].color = D3DCOLOR_RGBA( 255, 255, 0, 0);
	v2[i++].color = D3DCOLOR_RGBA( 128, 128, 128, 0);
	v2[i++].color = D3DCOLOR_RGBA( 0, 128, 128, 0);

	v2[i++].color = D3DCOLOR_RGBA( 128, 0, 128, 0);
	v2[i++].color = D3DCOLOR_RGBA( 128, 128, 0, 0);

	if( FAILED( pd->CreateVertexBuffer( 11*sizeof(CUSTOMVERTEX),0, 
								D3DFVF_CUSTOMVERTEX,D3DPOOL_DEFAULT, &pvb2 ) ) )return 0;
	void* p2;
	if( FAILED( pvb2->Lock( 0, 8*sizeof(CUSTOMVERTEX), (BYTE**)&p2, 0 ) ) )return 0;
	memcpy( p2, v2, 11*sizeof(CUSTOMVERTEX) );
	pvb2->Unlock();
		
	return 1;
}

void Scene::SaveScreen_BMP()
{
	int scr_size_x; int scr_size_y;
	IDirect3DSurface8 *sur;
	D3DDISPLAYMODE Mode;
	
	pd->GetDisplayMode( &Mode);
	Mode.Format = D3DFMT_A8R8G8B8;
	if(pd->CreateImageSurface(Mode.Width, Mode.Height, Mode.Format, &sur)!=D3D_OK )return;
	
	D3DSURFACE_DESC surd;
	if(pd->GetFrontBuffer( sur)!=D3D_OK){sur->Release(); return;}
	sur->GetDesc( &surd);

	D3DLOCKED_RECT LockedRect;
	if(sur->LockRect( &LockedRect, NULL, D3DLOCK_READONLY)!=D3D_OK)
	{
		sur->UnlockRect();
		sur->Release();
		return;
	}

	scr_size_x = surd.Width;
	scr_size_y = surd.Height;

	BITMAPFILEHEADER fileheader;
	BITMAPINFOHEADER infoheader;

	FILE *sub;
	int line_size = 3*scr_size_x;
	if(line_size%4)line_size += 4 - line_size%4;

	unsigned char* buf = new unsigned char[3*line_size*scr_size_y];
	char file[30];

	if(buf==NULL )
	{
		sur->UnlockRect();
		sur->Release();
		return;
	}

	int Pitch = LockedRect.Pitch;
	unsigned char* p = (unsigned char*) LockedRect.pBits;
	for(unsigned int y=0; y<surd.Height; y++)
	{
		for(unsigned int x=0; x<surd.Width; x++)
		{
			buf[line_size*y+3*x+0] = p[Pitch*(surd.Height-y-1)+4*x+0];
			buf[line_size*y+3*x+1] = p[Pitch*(surd.Height-y-1)+4*x+1];
			buf[line_size*y+3*x+2] = p[Pitch*(surd.Height-y-1)+4*x+2];
		}
	}
	sur->UnlockRect();
	sur->Release();

	for(int c=0;c<999;c++)
	{
		char pom[20];
		strcpy(file,"screen");
		if(c<100)strcat(file,"0");
		if(c<10)strcat(file,"0");
		strcat(file,itoa(c,pom,10));
		strcat(file,".bmp");
		sub = fopen(file,"r");
		if(sub==NULL)break;
		if(sub!=NULL)fclose(sub);
	}
	
	fileheader.bfType = 0x4D42; // Magic identifier   - "BM"	| identifikacia BMP suboru musi byt "BM"
	fileheader.bfSize = 3*scr_size_x*scr_size_y+sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);	// File size in bytes			| velkos suboru v byte
	fileheader.bfReserved1 = 0;
	fileheader.bfReserved2 = 0;
	fileheader.bfOffBits = sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);	// Offset to image data, bytes	| posun na zaciatok dat
	
	infoheader.biSize = sizeof(BITMAPINFOHEADER);	// Header size in bytes			| velkost hlavicky BITMAPINFOHEADER
	infoheader.biWidth = scr_size_x;	// Width of image			| sirka obrazka - sizeX
	infoheader.biHeight = scr_size_y;	// Height of image			| vyska obrazka - sizeY
	infoheader.biPlanes = 1;		// Number of colour planes	| pocet farebnych rovin musi bit 1
	infoheader.biBitCount = 24;		// Bits per pixel			| bitov na pixel moze bit 1,4,8,24
	infoheader.biCompression = 0;	// Compression type			| typ compresie , 0 - bez kompresie
	infoheader.biSizeImage = line_size*infoheader.biHeight ;	// Image size in bytes		| velkost obrazka v byte
	infoheader.biXPelsPerMeter = 0;	// Pixels per meter X		| pixelov na meter v smere x
	infoheader.biYPelsPerMeter = 0;	// Pixels per meter Y		| pixelov na meter v smere y
	infoheader.biClrUsed = 0;		// Number of colours		| pocet  farieb v palete, ak 0 vsetky su pouzivane
	infoheader.biClrImportant = 0;	// Important colours		| dolezite farby v palete, ak 0 vsetky su dolezite
	
	sub = fopen(file,"wb");
	fwrite( &fileheader, sizeof(BITMAPFILEHEADER), 1, sub);
	fwrite( &infoheader, sizeof(BITMAPINFOHEADER), 1, sub);
	fwrite( buf, line_size*scr_size_y, 1, sub);

	delete[] buf;
	fclose(sub);
}
